﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System.Collections.Generic;
using System.Globalization;
using HeuristicLab.Common;
using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
using HeuristicLab.Persistence;

namespace HeuristicLab.Problems.GeneticProgramming.Robocode {
  [StorableType("4c78cf3c-2dd8-4904-abe9-0c74f8d50386")]
  public class Number : Symbol {
    public override int MinimumArity { get { return 0; } }
    public override int MaximumArity { get { return 0; } }

    [StorableConstructor]
    protected Number(StorableConstructorFlag deserializing) : base(deserializing) { }
    protected Number(Number original, Cloner cloner) : base(original, cloner) { }

    public Number() : base("Number", "A number.") { }

    public override ISymbolicExpressionTreeNode CreateTreeNode() {
      return new NumberTreeNode(this);
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new Number(this, cloner);
    }
  }
}
